#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>


void do_index (char *filename) {
  int fd, indexfd;

  int delim_pos = 0, pos = 0, fortunes = 0, done = 0;
  char ch;

  struct stat statbuf;

  int fnlen = strlen (filename);
  char *indexfilename = malloc (fnlen + 7);

  fd = open (filename, O_RDONLY);
  if (fd == -1) {
    printf ("Couldn't open fortune file: %s\n", strerror (errno));
    return;
  }

  strcpy (indexfilename, filename);
  strcpy (indexfilename + fnlen, ".index");

  indexfd = open (indexfilename, O_WRONLY | O_TRUNC | O_CREAT, S_IWUSR | S_IRUSR | S_IRGRP | S_IROTH);
  if (indexfd == -1) {
    close (fd);
    printf ("Couldn't open index file: %s\n", strerror (errno));
    return;
  }

  free (indexfilename);

  lseek (indexfd, sizeof (int) * 2, SEEK_SET); /*skip header*/
  write (indexfd, &pos, sizeof (int));

  while (done != 1) {
    if (read (fd, (void *) &ch, 1) == 1) {
      pos++;
      if (ch == delimiter [delim_pos]) {
	delim_pos++;
	if (delim_pos >= delim_size) {
	  /*mark hit*/
	  write (indexfd, &pos, sizeof (int));
	  fortunes++;
	  delim_pos = 0;
	}
      } else {
	delim_pos = 0;
      }
    } else {
      done = 1;
    } 
  }

  /*end offset
  write (indexfd, &pos, sizeof (int));*/

  lseek (indexfd, 0, SEEK_SET);
  if (fstat (fd, &statbuf) == -1) {
    printf ("Error in stat: %s\n", strerror (errno));
  }
  write (indexfd, &fortunes, sizeof (int));
  write (indexfd, &statbuf.st_mtime, sizeof (int));

  printf ("Indexed %i fortunes at time %i.\n", fortunes, statbuf.st_mtime);

  close (fd);
  close (indexfd);
}

int main (int argc, char **argv) {

  if (argc > 1) {
    do_index (argv [1]);
  } else {
    printf ("This program requires an argument: the file to index\n");
  }

  return 0;
}

